<copyright> TOM configuration for default.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of TESLA.  TESLA is distributed under the terms of
    the GNU General Public License, a copy of which can be found in the
    TESLA distribution; see the file COPYING.

    <id>$Id: default.t,v 1.4 1999/10/04 20:12:07 tiggr Exp $</id>
    </copyright>

<doc> The {default} class provides default implementations for the
    description of things that are common to both a target and a host
    configuration.  </doc>
implementation class
default: mu

void
  initialize
{
}

String
  tom-config-name
{
  = "default";
}

end;

implementation instance
default

end;

<doc> The {host-default} class provides default implementations for the
    description of things in the host configuration.  I am not sure how
    much this is needed, but it does not harm to keep the skeleton generic.
    </doc>
implementation class
host-default: default

end;

implementation instance
host-default

end;

<doc> The {target-default} class provides default implementations for the
    description of things in the target configuration.  </doc>
implementation class
target-default: default
{
  <doc> Indexed by numeric {BT_*}, the required alignment in bits of a
      storage location of such a type.  </doc>
  static IntArray basic-type-alignment;
}

<doc> Initialize the {basic-type-alignment}.  </doc>
void
  initialize
{
  MutableIntArray mi = [MutableIntArray with (0, 8, 8, 16, 32, 64)];
  [mi add 32];
  [mi add 64];
  basic-type-alignment = mi;

  [super initialize];
}

<doc> Return the required alignment in bits of the {type}, which is one of
    those {mu}.{BT_*} thingies.  The default implementation returns
    {basic-type-alignment} for numeric types and retrieves the
    {alignment-of-pointer} for the non-numeric types.  </doc>
int
  alignment-of-basic-type int type
{
  if (type >= BT_BOOLEAN && type <= BT_DOUBLE)
    = basic-type-alignment[type];
  else
    = [self alignment-of-pointer];
}

<doc> Return the alignment in bits of a pointer type.  The default
    implementation returns 32.  Override this in your description of a 64
    bit CPU.  </doc>
int
  alignment-of-pointer
{
  = 32;
}

<doc> Return the required alignment in bits of the {type}, which is one of
    those {mu}.{BT_*} thingies.  The default implementation returns
    {basic-type-alignment} for numeric types and retrieves the
    {size-of-pointer} for the non-numeric types.  </doc>
int
  size-of-basic-type int type
{
  if (type >= BT_BOOLEAN && type <= BT_DOUBLE)
    = basic-type-alignment[type];
  else
    = [self size-of-pointer];
}

<doc> Return the size of a pointer.  The default implementation returns 32.
    Override this in your description of a 64 bit CPU.  </doc>
int
  size-of-pointer
{
  = 32;
}

end;

implementation instance
target-default

end;
