<copyright> TESLA Specials.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of TESLA.  TESLA is distributed under the terms of
    the GNU General Public License, a copy of which can be found in the
    TESLA distribution; see the file COPYING.

    <id>$Id: Special.t,v 1.8 1999/09/30 07:19:09 tiggr Exp $</id>
    </copyright>

/******************** Special ********************/

implementation class
Special: Expression

end;

implementation instance
Special
{
  <doc> The body.  </doc>
  mutable Expression body;
}

<doc> Do the {body}.  </doc>
TeslaOutput (of)
  compileBlocks TeslaOutput of
{
  [body compileBlocks of];
}

(Expression, Cons) (resolved, possible_types)
  resolve (Cons, Type) (expected, convertible)
  context Meta context_type
  nested: (MutableIntArray, int) (indices, index)
{
  if (!type)
    {
      Cons l;
      (body, l) = [body resolve (expected, convertible) context context_type
			nested: (indices, index)];
      Type t = [body type];
      if (t != nil)
	type = [body type];
      else
	return (self, l);
    }
  = [super resolve (expected, convertible) context context_type
	   nested: (indices, index)];
}

end;

/******************** Bind ********************/

implementation class
Bind: Special
{
  <doc> The expected types of a handler.  </doc>
  static Cons handler_types;
}

end;

implementation instance
Bind
{
  <doc> The handlers.  </doc>
  MutableArray handlers;
}

<doc> Designated initializer.  </doc>
id
  initWithHandlers MutableArray a
{
  handlers = a;
  = [super initWithType nil];
}

void
  coarseUsage int f
       parent Compound c
	 body MethodBody m
{
  [super coarseUsage f parent c body m];
  [body coarseUsage f parent c body m];
  int i, n = [handlers length];
  for (i = 0; i < n; i++)
    [handlers[i] coarseUsage EXPR_RHS | EXPR_BIND parent c body m];
}

<doc> Do the {handlers}.  </doc>
TeslaOutput (of)
  compileBlocks TeslaOutput of
{
  int i, n = [handlers length];
  for (i = 0; i < n; i++)
    [handlers[i] compileBlocks of];
  [super compileBlocks of];
}

Cexpr (result)
  precompile Cblock parent
      method Cblock method_body
{
  if (expr_flags & EXPR_RHS != 0)
    result = [type temporaryCexpr parent];

  Cblock bb = [[Cblock alloc self] initWithParent parent];

  int i, n = [handlers length];
  [bb add [[Ccode alloc self]
	   init "struct trt_bind *_bind_info = alloca (sizeof *_bind_info + "]];
  Cconst nconst = [[Cconst alloc self] init [[MutableByteString new] print n]];
  [bb add nconst];
  [bb add [[Cconst alloc self] init " * sizeof _bind_info->handlers[0]);"]];
  [bb add [[Cconst alloc self] init "_bind_info->tomc_handler = 0;"]];

  for (i = 0; i < n; i++)
    {
      ExpressionTuple ht = handlers[i];
      Expression cc = ht[0];
      Cexpr r = [cc precompile bb method method_body];
      Cexpr l = [[Cconst alloc cc] init [[MutableByteString new]
		      print ("_bind_info->handlers[", i, "].condition_class")]];
      [r compile bb assignmentTo l];

      Expression ch = ht[1];
      r = [ch precompile bb method method_body];
      l = [[Cconst alloc cc] init [[MutableByteString new]
		    print ("_bind_info->handlers[", i, "].condition_handler")]];
      [r compile bb assignmentTo l];
    }

  [bb add [[Casgn alloc] init ([[Cconst alloc] init "_bind_info->c.kind"],
			    [[Cconst alloc] init "TRT_CONDITION_KIND_BIND"])]];
  [bb add [[Casgn alloc] init ([[Cconst alloc] init "_bind_info->num"],
			       nconst)]];
  [bb add [[Cstmt alloc] init "trt_register (&_bind_info->c)"]];
  Cexpr body_result = [body precompile bb method method_body];
  if (result != nil)
    [body_result compile bb assignmentTo result];
  [bb add [[Cstmt alloc] init "trt_unwind (&_bind_info->c)"]];
  [parent add bb];
}

(Expression, Cons) (resolved, possible_types)
  resolve (Cons, Type) (expected, convertible)
  context Meta context_type
  nested: (MutableIntArray, int) (indices, index)
{
  if (!type)
    {
      if (!handler_types)
	handler_types = [Cons with ([TypeTuple with (top_type, condition_type)],
				    nil)];

      int i, n = [handlers length];
      for (i = 0; i < n; i++)
	{
	  Expression e = handlers[i];
	  Expression f = [e resolve (handler_types, nil) context context_type];
	  if (e != f)
	    handlers[i] = f;
	}
    }
  = [super resolve (expected, convertible) context context_type
	   nested: (indices, index)];
}

end;

/******************** Catch ********************/

implementation class
Catch: Special

end;

implementation instance
Catch
{
  <doc> The tag.  </doc>
  Expression tag;
}

<doc> Designated initializer.  </doc>
id
  initWithTag Expression t
{
  tag = t;
  = [super initWithType nil];
}

void
  coarseUsage int f
       parent Compound c
	 body MethodBody m
{
  [super coarseUsage f parent c body m];
  [body coarseUsage f parent c body m];
  [tag coarseUsage EXPR_RHS parent c body m];
}

<doc> Do the {body}.  </doc>
TeslaOutput (of)
  compileBlocks TeslaOutput of
{
  [tag compileBlocks of];
  [super compileBlocks of];
}

Cexpr (result)
  precompile Cblock parent
      method Cblock method_body
{
  int n;
  if (expr_flags & EXPR_RHS != 0)
    {
      result = [type temporaryCexpr parent];
      n = [type numFlatElements];
    }

  Cblock bb = [[Cblock alloc self] initWithParent parent];
  [bb add [[Cconst alloc self] init "jmp_buf _catch_buf; if (!setjmp (_catch_buf)) { struct trt_catch *_catch_info = alloca (sizeof *_catch_info + "]];
  [bb add [[Cconst alloc self] init [[MutableByteString new] print n]]];
  [bb add [[Cconst alloc self] init " * sizeof _catch_info->values[0]);"]];
  Cexpr tage = [tag precompile bb method method_body];
  [bb add [[Casgn alloc] init ([[Cconst alloc] init "_catch_info->c.kind"],
			    [[Cconst alloc] init "TRT_CONDITION_KIND_CATCH"])]];
  [bb add [[Casgn alloc] init ([[Cconst alloc] init "_catch_info->tag"],
			       tage)]];
  [bb add [[Casgn alloc] init ([[Cconst alloc] init "_catch_info->jmp"],
			    [[Cconst alloc] init "&_catch_buf"])]];
  TypeDescription td = [Type (!result ? void_type : type) typeDescription];
  [td noteUsage];
  MutableByteString tds = [[MutableByteString new] print "&"];
  [td writeCReferenceName tds];
  [bb add [[Casgn alloc] init ([[Cconst alloc] init "_catch_info->value_desc"],
			       [[Cconst alloc] init tds])]];
  if (result != nil)
    {
      Array a = [result collectFlatElements
			[MutableObjectArray withCapacity n]];
      int i;
      for (i = 0; i < n; i++)
	{
	  MutableByteString s = [[MutableByteString new]
				  print ("_catch_info->values[", i, "]")];
	  MutableByteString t = [[MutableByteString new] print "&"];
	  Cexpr ai = a[i];
	  [ai writeCFile Any (t)];
	  [bb add [[Casgn alloc] init ([[Cconst alloc] init s],
				       [[Cconst alloc] init t])]];
	}
    }
  [bb add [[Cstmt alloc] init "trt_register (&_catch_info->c)"]];

  Cexpr body_result = [body precompile bb method method_body];
  if (result != nil)
    [body_result compile bb assignmentTo result];
  [bb add [[Cconst alloc] init "trt_unwind (&_catch_info->c); }"]];
  [parent add bb];
}

(Expression, Cons) (resolved, possible_types)
  resolve (Cons, Type) (expected, convertible)
  context Meta context_type
  nested: (MutableIntArray, int) (indices, index)
{
  if (!type && ![tag type])
    tag = [tag resolve (top_type_list, nil) context context_type];

  = [super resolve (expected, convertible) context context_type
	   nested: (indices, index)];
}

end;

/******************** Unwind ********************/

implementation class
Unwind: Special

end;

implementation instance
Unwind
{
  <doc> The protection.  </doc>
  Expression protection;
}

<doc> Designated initializer.  </doc>
id
  initWithProtection Expression p
{
  protection = p;
  = [super initWithType nil];
}

void
  coarseUsage int f
       parent Compound c
	 body MethodBody m
{
  [super coarseUsage f parent c body m];
  [body coarseUsage f parent c body m];
  [protection coarseUsage EXPR_UNWIND parent c body m];
}

<doc> Do the {body}.  </doc>
TeslaOutput (of)
  compileBlocks TeslaOutput of
{
  [protection compileBlocks of];
  [super compileBlocks of];
}

Cexpr (result)
  precompile Cblock parent
      method Cblock method_body
{
  Cblock bb = [[Cblock alloc self] initWithParent parent];
  Cblock pp = [[Cblock alloc self] initWithParent parent];

  if (expr_flags & EXPR_RHS != 0)
    result = [type temporaryCexpr parent];

  [protection precompile pp method method_body];
  [bb add [[Cconst alloc] init "void _unwind (void) {"]];
  [bb add pp];
  [bb add [[Cconst alloc] init "}"]];
  [bb add [[Cstmt alloc self] init "struct trt_unwind _unwind_info; _unwind_info.c.kind = TRT_CONDITION_KIND_UNWIND; _unwind_info.protect = _unwind; trt_register (&_unwind_info.c)"]];
  Cexpr body_result = [body precompile bb method method_body];
  if (result != nil)
    [body_result compile bb assignmentTo result];
  [bb add [[Cstmt alloc] init "trt_unwind (&_unwind_info.c); _unwind ()"]];
  [parent add bb];
}

(Expression, Cons) (resolved, possible_types)
  resolve (Cons, Type) (expected, convertible)
  context Meta context_type
  nested: (MutableIntArray, int) (indices, index)
{
  if (!type && ![protection type])
    protection = [protection resolve (nil, nil) context context_type];
  = [super resolve (expected, convertible) context context_type
	   nested: (indices, index)];
}

end;
